
%if 0

lDebug - Free x86 DOS debugger

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

%include "debug.mac"

%ifndef _MAP
%elifempty _MAP
%else	; defined non-empty, str or non-str
	[map all _MAP]
%endif

	cpu 8086
	org 100h
	addsection lDEBUG_DATA_ENTRY, align=16 start=100h
data_entry_start:
	addsection ASMTABLE1, align=16 follows=lDEBUG_DATA_ENTRY
	addsection ASMTABLE2, align=16 follows=ASMTABLE1
	addsection lDEBUG_CODE, align=16 follows=ASMTABLE2 vstart=0
code_start:
	addsection DATASTACK, align=16 follows=ASMTABLE2 nobits
	addsection INIT, align=16 follows=lDEBUG_CODE vstart=0


	usesection lDEBUG_DATA_ENTRY




;	Equates for instruction operands.
;	First the sizes.

OP_ALL	equ 40h			; byte/word/dword operand (could be 30h but ...)
OP_1632	equ 50h			; word or dword operand
OP_8	equ 60h			; byte operand
OP_16	equ 70h			; word operand
OP_32	equ 80h			; dword operand
OP_64	equ 90h			; qword operand

OP_SIZE	equ OP_ALL		; the lowest of these

;	These operand types need to be combined with a size.

OP_IMM		equ 0		; immediate
OP_RM		equ 2		; reg/mem
OP_M		equ 4		; mem (but not reg)
OP_R_MOD 	equ 6		; register, determined from MOD R/M part
OP_MOFFS 	equ 8		; memory offset; e.g., [1234]
OP_R		equ 10		; reg part of reg/mem byte
OP_R_ADD 	equ 12		; register, determined from instruction byte
OP_AX		equ 14		; al or ax or eax

;	These don't need a size.

OP_M64		equ 2		; 0 qword memory (obsolete?)
OP_MFLOAT 	equ 4		; 1 float memory
OP_MDOUBLE 	equ 6		; 2 double-precision floating memory
OP_M80		equ 8		; 3 tbyte memory
OP_MXX		equ 10		; 4 memory (size unknown)
OP_FARMEM 	equ 12		; 5 memory far16/far32 pointer
OP_FARIMM	equ 14		; 6 far16/far32 immediate
OP_REL8		equ 16		; 7 byte address relative to IP
OP_REL1632 	equ 18		; 8 word or dword address relative to IP
OP_1CHK		equ 20		; 9 check for ST(1)
OP_STI		equ 22		;10 ST(I)
OP_CR		equ 24		;11 CRx
OP_DR		equ 26		;12 DRx
OP_TR		equ 28		;13 TRx
OP_SEGREG 	equ 30		;14 segment register
OP_IMMS8 	equ 32		;15 sign extended immediate byte
OP_IMM8		equ 34		;16 immediate byte (other args may be (d)word)
OP_MMX		equ 36		;17 MMx
OP_MMX_MOD	equ 38		;18 MMx, but in ModR/M part
OP_SHOSIZ 	equ 40		;19 set flag to always show the size

OP_1		equ 42		; 1 (simple "string" ops from here on)
OP_3		equ 44		; 3
OP_DX		equ 46		; DX
OP_CL		equ 48		; CL
OP_ST		equ 50		; ST (top of coprocessor stack)
OP_CS		equ 52		; CS
OP_DS		equ 54		; DS
OP_ES		equ 56		; ES
OP_FS		equ 58		; FS
OP_GS		equ 60		; GS
OP_SS		equ 62		; SS



	%include "asmtabs.asm"


	usesection lDEBUG_DATA_ENTRY

